BICO 1.1

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Pages
Public Member Functions | Public Attributes | List of all members
CluE::CFEntry< T > Struct Template Reference

Clustering feature tree entry. More...

`#include <cfentry.h>`

Inheritance diagram for CluE::CFEntry< T >:
Collaboration diagram for CluE::CFEntry< T >:

## Public Member Functions
| CFEntry (size_t number, T ls, double ss)
CFEntry & | operator+= (CFEntry const &x)
CFEntry & | operator-= (CFEntry const &x)
CFEntry | operator+ (CFEntry const &x) const
CFEntry | operator- (CFEntry const &x) const
void | insert (T const &x)
| Inserts a point. More...
void | remove (T const &x)
| Removes a point. More...
T | cog ()
| Returns the center of gravity. More...
double | kMeansCost (T const &center)
| 1-means clustering cost More...

## Public Attributes
size_t | number
| Number of points contained in the feature. More...
T | LS
| Linear sum. More...
double | SS
| Squared sum. More...
const bool | isWeighted

## Detailed Description

### template<typename T>
struct CluE::CFEntry< T >

Clustering feature tree entry.

Note
  This class expects the following overloaded operators:
  - + : T x T -> T and +=: (vector) sum
  - - : T x T -> T and -=: (vector) subtraction
  - * : T x T -> double: dot product

Clustering tree feature as described in T. Zhang, R. Ramakrishan and M. Livny. "BIRCH: A New Data Clustering Algorithm and Its Applications". Data Mining and Knowledge Discovery, 10.1023/A:1009783824328, 1997.

Definition at line 22 of file cfentry.h.

## Constructor & Destructor Documentation

template<typename T >

CluE::CFEntry< T >::CFEntry | ( | size_t | number,
|  | T | ls,
|  | double | ss
| ) |  |

Definition at line 69 of file cfentry.h.

## Member Function Documentation

template<typename T >

CFEntry< T > & CluE::CFEntry< T >::operator+= | ( | CFEntry< T > const & | x | ) |

Definition at line 77 of file cfentry.h.

template<typename T >

CFEntry< T > & CluE::CFEntry< T >::operator-= | ( | CFEntry< T > const & | x | ) |

Definition at line 85 of file cfentry.h.

template<typename T >

CFEntry< T > CluE::CFEntry< T >::operator+ | ( | CFEntry< T > const & | x | ) | const

Definition at line 93 of file cfentry.h.

template<typename T >

CFEntry< T > CluE::CFEntry< T >::operator- | ( | CFEntry< T > const & | x | ) | const

Definition at line 98 of file cfentry.h.

template<typename T >

void CluE::CFEntry< T >::insert | ( | T const & | x | ) |

Inserts a point.

Definition at line 103 of file cfentry.h.

template<typename T >

void CluE::CFEntry< T >::remove | ( | T const & | x | ) |

Removes a point.

Definition at line 116 of file cfentry.h.

template<typename T >

T CluE::CFEntry< T >::cog | ( |  | ) |

Returns the center of gravity.

Definition at line 129 of file cfentry.h.

template<typename T >

double CluE::CFEntry< T >::kMeansCost | ( | T const & | center | ) |

1-means clustering cost

Definition at line 134 of file cfentry.h.

## Member Data Documentation

template<typename T>

size_t CluE::CFEntry< T >::number

Number of points contained in the feature.

Definition at line 27 of file cfentry.h.

template<typename T>

T CluE::CFEntry< T >::LS

Linear sum.

Definition at line 32 of file cfentry.h.

template<typename T>

double CluE::CFEntry< T >::SS

Squared sum.

Definition at line 37 of file cfentry.h.

template<typename T>

const bool CluE::CFEntry< T >::isWeighted

Definition at line 39 of file cfentry.h.

The documentation for this struct was generated from the following file:

- src/clustering/cfentry.h